﻿//-------------------------------------------------------------------------------//
//Copyright (c) 2016, Vincent Bengtsson
//All rights reserved.

//Redistribution and use in source and binary forms, with or without
//modification, are permitted provided that the following conditions are met:

//1. Redistributions of source code must retain the above copyright notice, this
//   list of conditions and the following disclaimer. 
//2. Redistributions in binary form must reproduce the above copyright notice,
//   this list of conditions and the following disclaimer in the documentation
//   and/or other materials provided with the distribution.

//THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
//ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
//ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
//ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//The views and conclusions contained in the software and documentation are those
//of the authors and should not be interpreted as representing official policies, 
//either expressed or implied, of the FreeBSD Project.
//-------------------------------------------------------------------------------//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Diagnostics;
using System.Net.Sockets;

namespace CSharp_TCP_Messaging_System
{
    public partial class ClientWindow : System.Windows.Forms.Form
    {
        TcpClient Client = new TcpClient();
        private void Button1_Click(System.Object sender, System.EventArgs e)
        {
            if (TextBox1.Text.Contains(":") == true)
            {
                try
                {
                    Client.Connect(TextBox1.Text.Split(new char[1] { ':' })[0], int.Parse(TextBox1.Text.Split(new char[1] { ':' })[1]));
                    TextBox2.Enabled = true;
                    Button2.Enabled = true;
                    TextBox1.Enabled = false;
                    Button1.Enabled = false;
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Couldn't connect to server:" + Environment.NewLine + ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("Invalid IP address.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void Button2_Click(System.Object sender, System.EventArgs e)
        {
            TcpMessagePacket MessagePacket = new TcpMessagePacket(System.Text.Encoding.Default.GetBytes(TextBox2.Text), TcpMessagePacket.PacketHeader.PlainText);
            MessagePacket.Send(ref Client);
            TextBox2.Clear();
        }

        private void ClientWindow_FormClosing(object sender, System.Windows.Forms.FormClosingEventArgs e)
        {
            if (Client != null)
            {
                Client.GetStream().Close();
                Client.Close();
                Client.Client.Dispose();
            }
        }

        public ClientWindow()
        {
            InitializeComponent();
            FormClosing += ClientWindow_FormClosing;
        }
    }
}